#define LANModem "192.168.1.1"
#define PASSWORD "yourpassword\r\n"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <netdb.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/errno.h>
#include <ctype.h>
#include <fcntl.h>
#include <unistd.h>
#include <X11/Xlib.h>
#include <X11/xpm.h>
#include <X11/extensions/shape.h>
#include "../wmgeneral/wmgeneral.h"
#include "../wmgeneral/misc.h"
#include "master.xpm"

#define WMLAN_VERSION "1.1"

char wmlan_mask_bits[64*64];
int wmlan_mask_width = 64;
int wmlan_mask_height = 64;

extern int errno;
int sock;
FILE *fd;

void printversion(void);
void usage(void);

int socket_open(void)
{
 int sock;
 struct sockaddr_in server;
 
 server.sin_family = AF_INET;
 server.sin_port = htons(23);
 server.sin_addr.s_addr = inet_addr(LANModem);

 if ((sock = socket(PF_INET, SOCK_STREAM, 6)) < 0) {
  perror ("socket");
  exit (1);
 }
 if (connect(sock, (struct sockaddr *)&server, sizeof(server))) {
  perror ("connect");
  exit (1);
 }
 return sock;
}

int login(void)
{
 char *strn;
 int readz;

 strn=malloc(2048);
 sock=socket_open();

 readz=read(sock,strn,1024);
 readz=read(sock,strn,1024);
 write(sock,PASSWORD,20);
 readz=read(sock,strn,1024);
 readz=read(sock,strn,1024);
 free(strn);
 printf ("\ndebug: we are logged in\n");
}

void smallprint(int i, int *k)
{
 switch (i) {
  case -1:
   *k -= 5;
   copyXPMArea(13*5-5, 86, 4, 9, *k, 49);
  break;
  case 0:
   *k -= 5;
   copyXPMArea(45, 86, 5, 9, *k, 49);
  break;
  default:
   *k -= 5;
   copyXPMArea(i*5-5, 86, 5, 9, *k, 49);
  break;
 }
}

void speedisp(int speed)
{
 int i, k;
 char *p;
 k = 31;
 
 i = (speed % 1000) / 100;
 speed /= 1000;
 smallprint(i, &k);
 
 k -= 5;
 copyXPMArea(50, 86, 5, 9, k, 49);
 
 do {
  smallprint(speed % 10, &k);
  speed /= 10;
 } while (speed);
}

void drawtime(int i)
{
 int time_left=i/60;
 int hour_left,min_left;
 hour_left=time_left/60;
 min_left=time_left%60;
 copyXPMArea((hour_left/10)*6+1,65,5,7,6,6);
 copyXPMArea((hour_left%10)*6+1,65,5,7,12,6);
 copyXPMArea(62,66,1,6,19,7);
 copyXPMArea((min_left/10)*6+1,65,5,7,22,6);
 copyXPMArea((min_left%10)*6+1,65,5,7,28,6);
}

void drawip(unsigned int i)
{
 struct in_addr addr;
 char *ip;
 char *bogus;
 int p1,p2,p3,p4;
 
 bogus=malloc(10);
 addr.s_addr=htonl(i);
 ip=inet_ntoa(addr);
 p1=atoi(ip);
 sprintf(bogus,"%03i",p1);
 copyXPMArea((bogus[0]-48)*4+1,116,3,5,7,35);
 copyXPMArea((bogus[1]-48)*4+1,116,3,5,11,35);
 copyXPMArea((bogus[2]-48)*4+1,116,3,5,15,35);
 ip=strchr(ip,'.');ip++;
 p2=atoi(ip);
 sprintf(bogus,"%03i",p2);
 copyXPMArea((bogus[0]-48)*4+1,116,3,5,20,35);
 copyXPMArea((bogus[1]-48)*4+1,116,3,5,24,35);
 copyXPMArea((bogus[2]-48)*4+1,116,3,5,28,35);
 ip=strchr(ip,'.');ip++;
 p3=atoi(ip);
 sprintf(bogus,"%03i",p3);
 copyXPMArea((bogus[0]-48)*4+1,116,3,5,33,35);
 copyXPMArea((bogus[1]-48)*4+1,116,3,5,37,35);
 copyXPMArea((bogus[2]-48)*4+1,116,3,5,41,35);
 ip=strchr(ip,'.');ip++;
 p4=atoi(ip);
 sprintf(bogus,"%03i",p4);
 copyXPMArea((bogus[0]-48)*4+1,116,3,5,46,35);
 copyXPMArea((bogus[1]-48)*4+1,116,3,5,50,35);
 copyXPMArea((bogus[2]-48)*4+1,116,3,5,54,35);
 free(bogus);
}

void press(XButtonEvent *ev)
{
 int x=ev->x;
 int y=ev->y;
 char *strn;
 
 strn=malloc(1030);
 
 if(CheckMouseRegion(x,y)==1) {
   write(sock,"disc 0\r\n",30);
   read(sock,strn,1024);
   read(sock,strn,1024);
 }

 if(CheckMouseRegion(x,y)==0) {
   write(sock,"conn 0\r\n",30);
   read(sock,strn,1024);
   read(sock,strn,1024);
 }
 free(strn);
}

int wmlan_routine(int argc, char **argv)
{
 char *cpu,*system,*strn;
 char *cpup,*systemp,*strnp;
 int cpulen;
 int systemlen;
 int readz;
 int idle,calltime;
 int rxload,txload;
 int rxcnt,txcnt;
 int cpuload;
 int speed;
 int callstate;
 char ip[9];
 unsigned int ipd;
 int done=0;

 XEvent Event;

  strn=malloc(1024);
  strnp=strn;
  cpu=malloc(1024);
  cpup=cpu;
  system=malloc(1024);
  systemp=system;
 
 createXBMfromXPM(wmlan_mask_bits, master_xpm, wmlan_mask_width, wmlan_mask_height);
 openXwindow(argc, argv, master_xpm, wmlan_mask_bits, wmlan_mask_width, wmlan_mask_height);

 AddMouseRegion(0,35,48,46,58);
 AddMouseRegion(1,48,48,58,58);

 while(1) {

  write(sock,"stats c\r\n",30);
  readz=read(sock,strn,1024);
  systemlen=read(sock,system,1024);
  system[systemlen]=0;
  write(sock,"stats s\r\n",30);
  readz=read(sock,strn,1024);
  cpulen=read(sock,cpu,1024);cpu[cpulen]=0;

  system=strstr(system,"Message :");system=system+10;speed=atoi(system);
  if (speed>0) {
   system=strstr(system,"IP Addr:");system=system+8;
   strncpy(ip,system,8);
   ip[8]=0;
   sscanf(ip,"%x",&ipd);
   if (ip[1]==',') ipd=0;
   system=strstr(system,"CallLen:");system=system+8;calltime=atoi(system);
   system=strstr(system,"IdleLen:");system=system+8;idle=atoi(system);
   system=strstr(system,"RX Utilization:");system=system+15;rxload=atoi(system);
   system=strstr(system,"TX Utilization:");system=system+15;txload=atoi(system);
   if (txload>94) txload=94; if (txload<0) txload=0;
   if (rxload>94) rxload=94; if (rxload<0) rxload=0;
   system=strstr(system,"RX Octets:");system=system+10;rxcnt=atoi(system);
   system=strstr(system,"TX Octets:");system=system+10;txcnt=atoi(system);
  } else {
   ipd=0;txload=0;rxload=0;calltime=0;
  }
  cpu=strchr(cpu,'=');cpu++;
  cpuload=atoi(cpu);
  
  // blank out
  copyXPMArea(67,65,47,5,10,21);
  copyXPMArea(67,65,47,5,10,27);
  copyXPMArea(87,54,19,10,40,5);

  done++;

  if (done==1) {
   speedisp(speed);
   drawip(ipd);
   done=-10;
  }

  drawtime(calltime);
  copyXPMArea(67,71,(txload/2),5,10,21);
  copyXPMArea(67,71,(rxload/2),5,10,27);
  copyXPMArea(67,54,(cpuload/5),10,40,5);
  
  RedrawWindow();

  while (XPending(display)) {
   XNextEvent(display, &Event);
   switch (Event.type) {
    case Expose:
     RedrawWindow();
    break;
    case ButtonPress:
     press(&Event.xbutton);
    break;
    case DestroyNotify:
     XCloseDisplay(display);
     exit(0);
    break;
   }
  } 
  strn=strnp;system=systemp;cpu=cpup;
  usleep(1000000);
 }
}

int main(int argc, char *argv[]) {
 int i;
 for (i=1; i<argc; i++) {
  char *arg = argv[i];
  if (*arg=='-') {
   switch (arg[1]) {
    case 'd':
     if (strcmp(arg+1, "display")) {
      usage();
      exit(1);
     }
    break;
    case 'v':
     printversion();
     exit(0);
     break;
    default:
     usage();
     exit(0);
    break;
   }
  }
 }
 login();
 wmlan_routine(argc, argv);
}

void usage(void)
{
 fprintf(stderr, "\nWMLan - 3Com LanModem Monitor\nby TimeCop [timecop@linuxwarez.com]\n\n");
 fprintf(stderr, "usage:\n");
 fprintf(stderr, "    -d <display>\tconnect to whatever display\n");
 fprintf(stderr, "    -h\t\t\tthis text\n");
 fprintf(stderr, "    -v\t\t\tprint the version number\n");
 fprintf(stderr, "\n");
}

void printversion(void)
{
 fprintf(stderr, "wmlan v%s\n", WMLAN_VERSION);
}
